#include "ppc.h"
#include "m33.h"

PPC::PPC(int _w, int _h, float hfov) : w(_w), h(_h) {

	C = V3(0.0f, 0.0f, 0.0f);
	a = V3(1.0f, 0.0f, 0.0f);
	b = V3(0.0f, -1.0f, 0.0f);
	float h2 = hfov*3.1415926f / 180.0f / 2.0f;
	c = V3(-0.5f*(float)w, 0.5f*(float)h, -(float)w / (2.0f*tanf(h2)));

}

int PPC::Project(V3 P, V3& projP) {

	M33 cam;
	cam.SetColumn(0, a);
	cam.SetColumn(1, b);
	cam.SetColumn(2, c);

	V3 q = cam.Inverted()*(P - C);

	if (q[2] <= 0.0f)
		return 0;

	projP = q / q[2];

	return 1;

}